/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package presentacion;

import java.sql.ResultSet;
import javax.swing.JOptionPane;
import logica.Articulo;
import logica.Categoria;
import logica.Linea;
import logica.Marca;
import util.Funciones;

/**
 *
 * @author silviopd
 */
public class FrmArticuloAgregarEditar2 extends javax.swing.JDialog {

    /**
     * Creates new form FrmArticuloAgregarEditar2
     */
    
    public String operacion;
    public int valorRetorno = 0;
    
    public FrmArticuloAgregarEditar2(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        
        /**ENVIAR A PRIMER PLANO (ADELANTE DE TODOS)**/
        toFront();
        
        cargarComboLinea();
        cargarComboCategoria(9);
        cargarComboMarca();
    }
    
    private void cargarComboLinea() {
        try {
            new Linea().llenarComboLinea(cboLinea);
        } catch (Exception e) {
            Funciones.mensajeError(e.getMessage(), Funciones.NOMBRE_SOFTWARE);
        }
    }

    private void cargarComboCategoria(int linea) {
        try {
            new Categoria().llenarComboCategoria(cboCategoria, linea);
        } catch (Exception e) {
            Funciones.mensajeError(e.getMessage(), Funciones.NOMBRE_SOFTWARE);
        }
    }

    private void cargarComboMarca() {
        try {
            new Marca().llenarComboMarca(cboMarca);
        } catch (Exception e) {
            Funciones.mensajeError(e.getMessage(), Funciones.NOMBRE_SOFTWARE);
        }
    }

    public void leerDatosArticulo(int codCat) {
        try {
            ResultSet resultado = new Articulo().leerDatosCodigo(codCat);
            if (resultado.next()) {
                txtCodigo.setText(String.valueOf(resultado.getInt("codigo_articulo")));
                txtNombre.setText(String.valueOf(resultado.getString("nombre")));
                txtPrecioVenta.setText(String.valueOf(resultado.getDouble("precio_venta")));
                cboLinea.setSelectedItem(String.valueOf(resultado.getString("linea")));
                cboCategoria.setSelectedItem(String.valueOf(resultado.getString("categoria")));
                cboMarca.setSelectedItem(String.valueOf(resultado.getString("marca")));
                txtStock.setText(String.valueOf(resultado.getInt("stock")));
                String tipo_articulo = resultado.getString("tipo_articulo");
                if (tipo_articulo.equalsIgnoreCase("I")) {
                    rbInsumo.isSelected();
                } else if (tipo_articulo.equalsIgnoreCase("P")) {
                    rbProducto.isSelected();
                } else {
                    rbRepuesto.isSelected();
                }

                if (resultado.getString("tiene_descuento").equalsIgnoreCase("S")) {
                    chkTieneDescuento.setSelected(true);
                    txtPorcentajeDescuento.setText(String.valueOf(resultado.getDouble("porcentaje_descuento")));
                } else {
                    chkTieneDescuento.setSelected(false);
                    txtPorcentajeDescuento.setText("0.00");
                }

            }
        } catch (Exception e) {
            Funciones.mensajeError(e.getMessage(), Funciones.NOMBRE_SOFTWARE);
        }
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        txtCodigo = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        txtNombre = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        txtPrecioVenta = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        cboLinea = new javax.swing.JComboBox<>();
        jLabel5 = new javax.swing.JLabel();
        cboCategoria = new javax.swing.JComboBox<>();
        jLabel6 = new javax.swing.JLabel();
        cboMarca = new javax.swing.JComboBox<>();
        jLabel7 = new javax.swing.JLabel();
        rbProducto = new javax.swing.JRadioButton();
        rbInsumo = new javax.swing.JRadioButton();
        rbRepuesto = new javax.swing.JRadioButton();
        jLabel9 = new javax.swing.JLabel();
        txtStock = new javax.swing.JTextField();
        chkTieneDescuento = new javax.swing.JCheckBox();
        jLabel8 = new javax.swing.JLabel();
        txtPorcentajeDescuento = new javax.swing.JTextField();
        btnSalir = new javax.swing.JButton();
        btnGuardar = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        jLabel1.setText("Código:");

        txtCodigo.setEditable(false);

        jLabel2.setText("Nombre:");

        jLabel3.setText("Precio de venta:");

        jLabel4.setText("Línea:");

        cboLinea.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        cboLinea.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cboLineaActionPerformed(evt);
            }
        });

        jLabel5.setText("Categoría:");

        cboCategoria.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));

        jLabel6.setText("Marca:");

        cboMarca.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));

        jLabel7.setText("Tipo de artículo:");

        rbProducto.setSelected(true);
        rbProducto.setText("Producto");

        rbInsumo.setText("Insumo");

        rbRepuesto.setText("Repuesto");

        jLabel9.setText("Stock:");

        chkTieneDescuento.setText("Tiene descuento");
        chkTieneDescuento.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                chkTieneDescuentoActionPerformed(evt);
            }
        });

        jLabel8.setText("Porcentaje descuento:");

        txtPorcentajeDescuento.setEditable(false);
        txtPorcentajeDescuento.setText("0.00");

        btnSalir.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/salir.png"))); // NOI18N
        btnSalir.setText("Salir");
        btnSalir.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSalirActionPerformed(evt);
            }
        });

        btnGuardar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/guardar.png"))); // NOI18N
        btnGuardar.setText("Guardar");
        btnGuardar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnGuardarActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jLabel9)
                    .addComponent(jLabel7)
                    .addComponent(jLabel6)
                    .addComponent(jLabel5)
                    .addComponent(jLabel4)
                    .addComponent(jLabel3)
                    .addComponent(jLabel2)
                    .addComponent(jLabel1))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(txtNombre)
                    .addComponent(txtPrecioVenta)
                    .addComponent(txtCodigo)
                    .addComponent(cboLinea, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(cboCategoria, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(cboMarca, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(rbProducto)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(rbInsumo)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(rbRepuesto))
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(btnGuardar)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(btnSalir))
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(chkTieneDescuento)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addComponent(jLabel8)))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(txtPorcentajeDescuento, javax.swing.GroupLayout.DEFAULT_SIZE, 53, Short.MAX_VALUE))
                    .addComponent(txtStock))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(txtCodigo, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(txtNombre, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(txtPrecioVenta, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel4)
                    .addComponent(cboLinea, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel5)
                    .addComponent(cboCategoria, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel6)
                    .addComponent(cboMarca, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel7)
                    .addComponent(rbProducto)
                    .addComponent(rbInsumo)
                    .addComponent(rbRepuesto))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel9)
                    .addComponent(txtStock, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(chkTieneDescuento)
                    .addComponent(jLabel8)
                    .addComponent(txtPorcentajeDescuento, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(27, 27, 27)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btnGuardar)
                    .addComponent(btnSalir))
                .addGap(30, 30, 30))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void cboLineaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cboLineaActionPerformed
        // TODO add your handling code here:
        if (cboLinea.getSelectedIndex() >= 0) {
            int linea = Linea.listarLineas.get(cboLinea.getSelectedIndex()).getCodigoLinea();
            cargarComboCategoria(linea);
        }
    }//GEN-LAST:event_cboLineaActionPerformed

    private void chkTieneDescuentoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_chkTieneDescuentoActionPerformed
        // TODO add your handling code here:
        boolean selected = chkTieneDescuento.isSelected();
        txtPorcentajeDescuento.setEditable(selected);
    }//GEN-LAST:event_chkTieneDescuentoActionPerformed

    private void btnSalirActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSalirActionPerformed
        // TODO add your handling code here:
        dispose();
    }//GEN-LAST:event_btnSalirActionPerformed

    private void btnGuardarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnGuardarActionPerformed
        // TODO add your handling code here:

        String nombre = txtNombre.getText();
        double precio_venta = Double.parseDouble(txtPrecioVenta.getText());
        //int linea = Linea.listarLineas.get(cboLinea.getSelectedIndex()).getCodigoLinea();
        int categoria = Categoria.listarCategorias.get(cboCategoria.getSelectedIndex()).getCodigoCategoria();
        int marca = Marca.listarMarcas.get(cboMarca.getSelectedIndex()).getCodigoMarca();
        String tipo_articulo;

        if (rbInsumo.isSelected()) {
            tipo_articulo = "I";
        } else if (rbProducto.isSelected()) {
            tipo_articulo = "P";
        } else {
            tipo_articulo = "R";
        }

        int stock = Integer.parseInt(txtStock.getText());

        String tiene_descuento;
        double porcentaje_descuento;

        if (chkTieneDescuento.isSelected()) {
            tiene_descuento = "S";
            porcentaje_descuento = Double.parseDouble(txtPorcentajeDescuento.getText());
        } else {
            tiene_descuento = "N";
            porcentaje_descuento = 0.00;
        }

        try {

            Articulo obj = new Articulo();

            obj.setNombre(nombre);
            obj.setPrecioVenta(precio_venta);
            obj.setCodigoCategoria(categoria);
            obj.setCodigoMarca(marca);
            obj.setStock(stock);
            obj.setTipoArticulo(tipo_articulo);
            obj.setTieneDescuento(tiene_descuento);
            obj.setPorcentajeDescuento(porcentaje_descuento);

            int respuesta = Funciones.mensajeConfirmacion("¿Estás seguro de grabar los datos?", Funciones.NOMBRE_SOFTWARE);
            if (respuesta != 0) {
                return;
            }

            boolean resultado;

            if (operacion.equalsIgnoreCase("agregar")) {
                resultado = obj.agregar();

                if (resultado) {
                    Funciones.mensajeInformacion("El registro se ha realizado con éxito...", Funciones.NOMBRE_SOFTWARE);
                    valorRetorno = 1;
                    dispose();
                }
            } else if (operacion.equalsIgnoreCase("editar")) {
                obj.setCodigoArticulo(Integer.parseInt(txtCodigo.getText()));

                resultado = obj.editar();

                if (resultado) {
                    Funciones.mensajeInformacion("Actualización éxitosa...", Funciones.NOMBRE_SOFTWARE);
                    valorRetorno = 1;
                    dispose();
                }
            }
        } catch (Exception e) {
            JOptionPane.showConfirmDialog(this, e);
        }
    }//GEN-LAST:event_btnGuardarActionPerformed

    /**
     * @param args the command line arguments
     */

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnGuardar;
    private javax.swing.JButton btnSalir;
    private javax.swing.JComboBox<String> cboCategoria;
    private javax.swing.JComboBox<String> cboLinea;
    private javax.swing.JComboBox<String> cboMarca;
    private javax.swing.JCheckBox chkTieneDescuento;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JRadioButton rbInsumo;
    private javax.swing.JRadioButton rbProducto;
    private javax.swing.JRadioButton rbRepuesto;
    private javax.swing.JTextField txtCodigo;
    private javax.swing.JTextField txtNombre;
    private javax.swing.JTextField txtPorcentajeDescuento;
    private javax.swing.JTextField txtPrecioVenta;
    private javax.swing.JTextField txtStock;
    // End of variables declaration//GEN-END:variables
}
